// sby Software de Arte

var estaVersion="1.1"; // tendria que haber una forma mas civilizada, pero no la encontre
var xmlRequest = new XMLHttpRequest();
var indice=0;
var cantidadObras=0;
var descargando=0;  // 0 es nada - 1 es descargando  2 - es descarga ok - 3 es actualizar - 4 es error
var srcAntiguo="";
var direccionCorreo="";
var paginaWeb="";
var tituloObra="";
var fotoObra= new Image();
var modo="obra";
var paginaWeb="";


//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    document.getElementById("versionTxt").innerText="Version: "+estaVersion; 
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    descargarXml();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


// mis metodos


function descargarXml(event){
    // setea el estado de descarga
    descargando=1;
    document.getElementById("datosButton").style.opacity=0.50;
    document.getElementById("webButton").style.opacity=0.50;
    document.getElementById("correoButton").style.opacity=0.50;
    document.getElementById("anteriorButton").style.opacity=0.50;
    document.getElementById("siguienteButton").style.opacity=0.50;
    
    //document.getElementById("paneles").object.setCurrentView(obra); 

    var feedURL = "http://www.tobeartist.com/vivo/tbaonwidget_consulta.php"; 
    var onloadHandler = function() { 
        xmlLoaded(xmlRequest); 
    };	// Función a la que va a llamarse cuando se cargue el canal; actualmente, llama al fragmento de código de carga XMLHttpRequest

    // Código de configuración XMLHttpRequest (el xmlRequest ya fue creado al comienzo)
    xmlRequest.onload = onloadHandler;
    xmlRequest.open("GET", feedURL);
    xmlRequest.setRequestHeader("Cache-Control", "no-cache");
    xmlRequest.send(null);
}


// Se llama cuando XMLHttpRequest carga un canal;
function xmlLoaded(xmlRequest) {

	if (xmlRequest.status == 200) { // la descarga esta ok
        if (xmlRequest.responseXML.documentElement.getElementsByTagName('version')[0].firstChild.data!=estaVersion){ // consulta version
            descargando=3; // actualizacion
            avisarActualizacion();
        }else{
            cantidadObras=xmlRequest.responseXML.documentElement.getElementsByTagName('obra').length;
            //descargando=2; // descarga ok  (todavia no, falta la foto)
            indice=cantidadObras-1;
            verObraElegida();
        }     
 	}else{
        descargando=4; // error en descarga
		// alert("Connection fail: Please try later");
	}    
}


function verObraElegida(){

	// Analizar e interpretar resultados
	// Resultados XML encontrados en xmlRequest.responseXML
	// Resultados de texto encontrados en xmlRequest.responseText
        
    nodoObra=xmlRequest.responseXML.documentElement.getElementsByTagName('obra')[indice];
     
    tituloObra=                                             nodoObra.getElementsByTagName('titulo')[0].firstChild.data;
    
    document.getElementById("titulo").innerText=            tituloObra;
    document.getElementById("artista").innerText=           "By "+nodoObra.getElementsByTagName('artista')[0].firstChild.data;	
    document.getElementById("disciplina").innerText=        nodoObra.getElementsByTagName('disciplina')[0].firstChild.data;
    document.getElementById("tecnica").innerText=           nodoObra.getElementsByTagName('tecnica')[0].firstChild.data;
    document.getElementById("talle").innerText=             nodoObra.getElementsByTagName('talle')[0].firstChild.data;
    document.getElementById("fechaProduccion").innerText=   nodoObra.getElementsByTagName('fechaProduccion')[0].firstChild.data;
    document.getElementById("descripcion").innerText=       nodoObra.getElementsByTagName('descripcion')[0].firstChild.data;
    document.getElementById("locacion").innerText=          nodoObra.getElementsByTagName('locacion')[0].firstChild.data;
    document.getElementById("precio").innerText=            nodoObra.getElementsByTagName('precio')[0].firstChild.data; 
     
    paginaWeb=                                              nodoObra.getElementsByTagName('webpage')[0].firstChild.data;
    direccionCorreo=                                        nodoObra.getElementsByTagName('email')[0].firstChild.data;
    rutaCadena=                                             nodoObra.getElementsByTagName('fotoUrl')[0].firstChild.data;
   
    // descargar y poner la imagen
    descargando=1;
    fotoObra.src = null;
    document.getElementById("fotoDescargada").src=null;
    fotoObra.src = rutaCadena;
    fotoObra.onload=function(){  
        document.getElementById("fotoDescargada").src=rutaCadena;
        descargando=2;
        document.getElementById("datosButton").style.opacity=1;   
        ajustarFoto();
        if (modo=="obra" && srcAntiguo!=rutaCadena){
            animarObjeto(document.getElementById("paneles"));
        }
        srcAntiguo=rutaCadena;
    }  

        if (indice==0){ 
            document.getElementById("anteriorButton").style.opacity=0.50;
        }else{
            document.getElementById("anteriorButton").style.opacity=1;
        }
        
         if (indice==cantidadObras-1){ 
            document.getElementById("siguienteButton").style.opacity=0.50;
        }else{
            document.getElementById("siguienteButton").style.opacity=1;
        }
        
        if (direccionCorreo!="" && direccionCorreo!="No data"){
            document.getElementById("correoButton").style.opacity=1;
        }else{
            document.getElementById("correoButton").style.opacity=0.50;
        } 
        
        if (paginaWeb!="" && paginaWeb!="No data"){
            document.getElementById("webButton").style.opacity=1;
        }else{
            document.getElementById("webButton").style.opacity=0.50;
        }  
                
}


function ajustarFoto(){
    // var anchoMarco=document.width-100 // solucion sucia (tendria que ser del marcoFoto)
    //  var altoMarco=document.height-150 // solucion sucia (tendria que ser del marcoFoto)
    var anchoMarco=parseInt(document.defaultView.getComputedStyle(document.getElementById("obra"), null).getPropertyValue("width"))+0;
    var altoMarco=parseInt(document.defaultView.getComputedStyle(document.getElementById("obra"), null).getPropertyValue("height"))-0;
    var anchoNuevo=0;
    var altoNuevo=0;

    if ((altoMarco/fotoObra.height)>(anchoMarco/fotoObra.width)){
        anchoNuevo=Math.min(anchoMarco,fotoObra.width);
        altoNuevo=fotoObra.height*(anchoNuevo/fotoObra.width);
    }else{
        altoNuevo=Math.min(altoMarco,fotoObra.height);
        anchoNuevo=fotoObra.width*(altoNuevo/fotoObra.height);
    }
    var arribaNuevo=(altoMarco-altoNuevo)/2;
    var izquierdaNuevo=(anchoMarco-anchoNuevo)/2;
 
    document.getElementById("fotoDescargada").style.width=anchoNuevo+"px";
    document.getElementById("fotoDescargada").style.height=altoNuevo+"px";
    document.getElementById("fotoDescargada").style.top=arribaNuevo+"px";
    document.getElementById("fotoDescargada").style.left=izquierdaNuevo+"px";
    
}


function verAnterior(event){
    if (indice>0 && descargando==2){
        indice--;
        verObraElegida();
    }
}


function verSiguiente(event){
    if (indice<cantidadObras-1 && descargando==2){
        indice++;
        verObraElegida();
    }
}


function mandarMail(event){
    if (direccionCorreo!="" && direccionCorreo!="No data" && descargando==2){
      var encodedEmailAddress = encodeURI(direccionCorreo);
      var encodedSubject = encodeURI("I saw: - "+tituloObra+" - in To be Artist");
      widget.openURL("mailto:" + encodedEmailAddress  + "?subject=" + encodedSubject);
    }
}


function irASitioWeb(event){
    if (paginaWeb!="" && paginaWeb!="No data" && descargando==2){
      widget.openURL(paginaWeb);
    } 
}


function mandarMailSda(event){
    var parte4=".com";
    var parte3="softwaredearte";
    var parte1="soft";
    var parte2="@";
    var encodedEmailAddress = encodeURI(parte1+parte2+parte3+parte4);
    var encodedSubject = encodeURI("Message from To be Artist (on Widget)");
    widget.openURL("mailto:" + encodedEmailAddress  + "?subject=" + encodedSubject);
}

function irASitioWebTba(event){
    widget.openURL("http://www.tobeartist.com");
}


function cambioPanel(event){
    if (modo=="obra" && descargando==2) {
        verDatos();
        return;
    }
    if (modo=="datos" && descargando==2) {
        verObra();
        return;
    }
}


function verDatos(event){
    if (descargando!=2){ // solo muestra datos si la descarga es ok
        return;
    }  
    animarObjeto(document.getElementById("paneles"));
    document.getElementById("paneles").object.setCurrentView(datos);
    modo="datos";
}


function verObra(event){
    if (descargando!=2){ // solo muestra datos si la descarga es ok
        return;
    } 
    modo="obra"; 
    animarObjeto(document.getElementById("paneles"));
    document.getElementById("paneles").object.setCurrentView(obra);
    ajustarFoto();
}


function animarObjeto(objetoAAnimar){
    objetoAAnimar.style.opacity =0;
    // Values you provide
    duration = 500;	// The length of the animation
    interval = 13;	// How often the animation should change
    start = 0.0;	// The starting value
    finish = 1.0;	// The finishing value
    handler = function(animation, current, start, finish) {
        // Called every interval; provides a current value between start and finish
        objetoAAnimar.style.opacity = current;
    }

    // Animation code
    new AppleAnimator(duration, interval, start, finish, handler).start();
}


function avisarActualizacion(){
    modo="actualizar";   
    document.getElementById("versionNuevaTxt").innerText=xmlRequest.responseXML.documentElement.getElementsByTagName('version')[0].firstChild.data;
    animarObjeto(document.getElementById("paneles"));
    document.getElementById("paneles").object.setCurrentView(actualizador);
}


function descargarActualizacion(event){
     widget.openURL("http://www.tobeartist.com/descargas/TBAonWidget.zip");
}



